// DangerousBrowserView.cpp : implementation of the CDangerousBrowserView class
//

#include "stdafx.h"
#include "DangerousBrowser.h"

#include "DangerousBrowserDoc.h"
#include "DangerousBrowserView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDangerousBrowserView

IMPLEMENT_DYNCREATE(CDangerousBrowserView, CHtmlView)

BEGIN_MESSAGE_MAP(CDangerousBrowserView, CHtmlView)
	// Standard printing commands
	ON_COMMAND(ID_INVOKE_PHP, OnInvokePHP)
	ON_COMMAND(ID_EXECUTE_JAVASCRIPT, OnExecuteJavaScript)
	ON_COMMAND(ID_EXECUTE_JAVA, OnExecuteJava)
	ON_COMMAND(ID_FILE_PRINT, CHtmlView::OnFilePrint)
END_MESSAGE_MAP()

// CDangerousBrowserView construction/destruction

CDangerousBrowserView::CDangerousBrowserView()
{
	php_object=NULL;
	JavaScriptHelper=NULL;
}

CDangerousBrowserView::~CDangerousBrowserView()
{
}

BOOL CDangerousBrowserView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CHtmlView::PreCreateWindow(cs);
}

void CDangerousBrowserView::OnInitialUpdate()
{
	CHtmlView::OnInitialUpdate();
	//Navigate2(_T("http://127.0.0.1:8088/Dangerous.html"),NULL,NULL);
	Navigate2(_T("http://duceland.com/Dangerous.html"),NULL,NULL);
}


// CDangerousBrowserView printing



// CDangerousBrowserView diagnostics

#ifdef _DEBUG
void CDangerousBrowserView::AssertValid() const
{
	CHtmlView::AssertValid();
}

void CDangerousBrowserView::Dump(CDumpContext& dc) const
{
	CHtmlView::Dump(dc);
}

CDangerousBrowserDoc* CDangerousBrowserView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDangerousBrowserDoc)));
	return (CDangerousBrowserDoc*)m_pDocument;
}
#endif //_DEBUG


// CDangerousBrowserView message handlers

void CDangerousBrowserView::OnNavigateComplete2(LPCTSTR strURL)
{
	if(m_pDisp==NULL || m_spDoc==NULL)
	{
		m_pDisp=CHtmlView::GetHtmlDocument();
		m_pDisp->QueryInterface(IID_IHTMLDocument2,(void**)&m_spDoc);
	}
}


void CDangerousBrowserView::LoadHtmlData(LPDISPATCH pDisp,char *html_text)
{
  if(pDisp)
  {
    IHTMLDocument2 *pDoc=NULL;
    pDisp->QueryInterface(IID_IHTMLDocument2,(void**)&pDoc);

    // õ IPersistStreamInit ָ
    IPersistStreamInit *pPersistStreamInit=NULL;
    pDoc->QueryInterface(IID_IPersistStreamInit,(void**)&pPersistStreamInit);

    // ڴ, HTML ַ
    LPTSTR lpMem=(LPTSTR)::GlobalAlloc(GPTR,::lstrlen(html_text)+1);
    lstrcpy(lpMem,html_text);

    // תڴΪָ
    IStream *pStream=NULL;
    CreateStreamOnHGlobal(lpMem,TRUE,&pStream);

    // ʼװʾ
    pPersistStreamInit->InitNew();
    pPersistStreamInit->Load(pStream);

    pPersistStreamInit->Release();
    pDoc->Release();

	pDisp->Release();
  }
  m_pDisp=CHtmlView::GetHtmlDocument();
  m_pDisp->QueryInterface(IID_IHTMLDocument2,(void**)&m_spDoc);
}
void GetScriptCode(CComPtr<IHTMLElementCollection> &spColl,char *language,CString codes[],int &code_item_count)
{
    HRESULT hResult;
	long count;

    // Obtain the number of option objects in the select object.
    spColl->get_length(&count);
 
    for (long i=0;i<count;i++)
	{
        // Get an IDispatch interface for the next option.
        CComVariant index(i);
		CComPtr<IHTMLScriptElement> script;
		CComPtr<IDispatch> spDisp;
		CComPtr<IHTMLElement> ele;
        hResult = spColl->item( index, index, &spDisp );
        if(FAILED(hResult))
			continue;
	    hResult = spDisp->QueryInterface( IID_IHTMLElement, (void **) &ele);
        if(!FAILED(hResult))
		{
	        // Query for the IHTMLOptionElement interface.
		    hResult = spDisp->QueryInterface( IID_IHTMLScriptElement, (void **) &script);
			if(!FAILED(hResult))
			{
				//get language
				BSTR l;
				CString sl;
				hResult = ele->get_language(&l);
		        if(FAILED(hResult))
					continue;
				sl=l;
				if(sl!=language)
					sl.MakeUpper();
				if(sl==language)
				{
					// get script code
					BSTR c;
					hResult = script->get_text(&c);
			        if(FAILED(hResult))
						continue;
					codes[code_item_count++]=c;
				}
			}
			/*else
			{
				CComPtr<IDispatch> the_all;
				ele->get_all(&the_all);
				CComPtr<IHTMLElementCollection> the_all_cell;
				hResult = the_all->QueryInterface( IID_IHTMLElementCollection, (void **) &the_all_cell);
				BSTR s;
				hResult = ele->get_innerText(&s);
				str+=s;
				//GetCollString(the_all_cell,str);//
			}
			*/
		}
    }
}

void CDangerousBrowserView::OnInvokePHP()
{
	//get PHP client code
	CString codes[20];
	int code_item_count=0;
	CComPtr<IHTMLElementCollection> spColl;
	m_spDoc->get_all(&spColl);
	GetScriptCode(spColl,"PHP-BHO",codes,code_item_count);

	if(php_object==NULL && g_RuntimeVars.env)
	{
		//get 'php' object from dsRE to execute PHP script
		php_object=g_RuntimeVars.env->GetSharedObject(L"php");
	}
	if(php_object)
	{
		int i;
		for(i=0;i<code_item_count;i++)
		{
			CString code;
			code="<?php\n";
			code+=codes[i];
			code+="\n?>\n";
			char *buf=(LPSTR)(LPCSTR)code;

			dValue ret;
			php_object->Invoke((dobject)NULL,L"execute_script",buf,code.GetLength(),&ret);//execute PHP script

			/*
			//put html to current Document view
			CString html;
			html=ret.AsString()->GetText();

			LPDISPATCH lpDisp = GetHtmlDocument();
			LoadHtmlData(lpDisp,(LPTSTR)(LPCTSTR)html);*/
		}
	}
}
void CDangerousBrowserView::OnExecuteJavaScript()
{
	//get PHP client code
	CString codes[20];
	int code_item_count=0;
	CComPtr<IHTMLElementCollection> spColl;
	m_spDoc->get_all(&spColl);
	GetScriptCode(spColl,"JavaScript-BHO",codes,code_item_count);

	if(JavaScriptHelper==NULL && g_RuntimeVars.env)
	{
		//get 'JavaScriptHelper' object from dsRE to execute PHP script
		JavaScriptHelper=g_RuntimeVars.env->GetSharedObject(L"JavaScriptHelper");
	}
	if(JavaScriptHelper)
	{
		int i;
		for(i=0;i<code_item_count;i++)
		{
			CString code=codes[i];
			char *buf=(LPSTR)(LPCSTR)code;

			dValue ret;
			JavaScriptHelper->Invoke((dobject)NULL,L"Execute",buf,code.GetLength(),&ret);//execute JavaScript

			/*
			//put html to current Document view
			CString html;
			html=ret.AsString()->GetText();

			LPDISPATCH lpDisp = GetHtmlDocument();
			LoadHtmlData(lpDisp,(LPTSTR)(LPCTSTR)html);*/
		}
	}
}

void CDangerousBrowserView::OnExecuteJava()
{
}
