unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  dVM, StdCtrls,
  StrUtils;

type
  TForm1 = class(TForm)
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;
var
  Form1: TForm1;

type
  CSharpUIDelphiBL = class
  public
    function OnButton1Click(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
    function OnEdit1Change(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
  public
  Button1,Edit1,Memo1 :WideString;
  dVM :TdVM;
  UI :WideString;
end;

var
  ui :CSharpUIDelphiBL;

implementation

{$R *.dfm}

procedure CreateCSharpUI();
var
  dn_bridge:WideString;
begin
  ui := CSharpUIDelphiBL.Create;
  ui.dVM :=TdVM.Create();
  ui.dVM.Build();
  ui.dVM.LoadBridge('DotNET_Bridge_ThroughVC.dll','');

  dn_bridge :=ui.dVM.DefaultNewObject('DotNET_Bridge','');
  ui.dVM.Invoke('obj_0',PWideChar(dn_bridge),'LoadDotNETLibrary','"CSharpUI.dll"');


  ui.UI := ui.dVM.DefaultNewObject('CSharpUI.CSharpForm','');
  ui.dVM.Invoke('obj_0',PWideChar(ui.UI),'StartupMe','');

  ui.Button1 := ui.dVM.GetSharedObject('Button1');
  ui.dVM.DelegatedStdcall(PWideChar(ui.Button1),'Click','',0,ui,ui.OnButton1Click);

  ui.Edit1 := ui.dVM.GetSharedObject('Edit1');
  ui.dVM.DelegatedStdcall(PWideChar(ui.Edit1),'TextChanged','',0,ui,ui.OnEdit1Change);

  ui.Memo1 := ui.dVM.GetSharedObject('Memo1');
end;

function CSharpUIDelphiBL.OnButton1Click(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
var
  v,ret:WideString;
begin
  v := '"'#$D#$A'Button1 clicked."';
  dVM.SetField(PWideChar(Memo1),'Text',PWideChar(v));
end;
function CSharpUIDelphiBL.OnEdit1Change(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
var
  v,text:WideString;
begin
  text := dVM.GetField(PWideChar(Edit1),'Text');
  v := '"'#$D#$A'Edit1 changed('+text+')"';
  dVM.SetField(PWideChar(Memo1),'Text',PWideChar(v));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ui.dVM.Destroy;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 CreateCSharpUI();
end;
end.
