import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
public class CSharpUI_JavaBL{
  public void OnButton1Click()
  {
    String t="\"Button1 clicked.\"";
    dVM.dvm.SetField(Memo1,"Text",t);
  }
  public void OnEdit1Change()
  {
    String edit1_text=dVM.dvm.GetField(Edit1,"Text");
    String t="\"Edit1 changed("+edit1_text+").\"";
    dVM.dvm.SetField(Memo1,"Text",t);
  }

  String Button1,Edit1,Memo1;
  String UI;
  
  public void StartupMe()
  {
		JFrame frame=new JFrame("Swing Application");
		frame.addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		});
		frame.setVisible(true);

    if(dVM.dvm==null)
    {
      dVM.dvm=new dVM();
      dVM.dvm.createVM();
    }

    dVM.dvm.VMLoadBridge("DotNET_Bridge_ThroughVC.dll","");
    String vcl_bridge=dVM.dvm.createObject("DotNET_Bridge","");
    dVM.dvm.Invoke("obj_0",vcl_bridge,"LoadDotNETLibrary","\"CSharpUI.dll\"");

    UI=dVM.dvm.createObject("CSharpUI.CSharpForm","");
    dVM.dvm.Invoke("obj_0",UI,"StartupMe","");
    
    Button1=dVM.dvm.GetSharedObject("Button1");
    Edit1=dVM.dvm.GetSharedObject("Edit1");
    Memo1=dVM.dvm.GetSharedObject("Memo1");

    dVM.dvm.delegateMethod(Button1,"Click",this,dVM.dvm.getMethodByName(getClass(),"OnButton1Click"));
    dVM.dvm.delegateMethod(Edit1,"TextChanged",this,dVM.dvm.getMethodByName(getClass(),"OnEdit1Change"));
  }
};
