import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.lang.reflect.*;

public class dVM
{
  static
  {
    System.loadLibrary("dsRE");
  }
  public native static int CreateVM();
  public native static void SetDefaultVM(int vm,int env,int factory);
  public native static int VMLoadBridge(String lib_file,String param);
  public native static String NewDefaultObject(String name,String param);
  public native static String Invoke(Object sender,String obj,String method_name,String param);
  public native static void DelegateMethod(String delegated_obj,String method_name,int receiver_index,String methodName,String methodString,String retType);
  public native static String GetField(String shost,String field_name);
  public native static void SetField(String shost,String field_name,String field_value);

  public native static String ShareExists(int obj_index,String cls_name,String share_name);
  public native static String GetSharedObject(String shared_name);
  
  public native static void MessageBox(String caption);

  static dVM dvm;//from dsRE.dll

  static JTextArea theMemo;

  public dVM()
  {
    dvm=this;
  }
  public int createVM()
  {
    int ret=CreateVM();
    LBridge.Bridge=new LBridge();
    LBridge.Bridge.hintJEnv();
    loadBridge("Java_Bridge.dll","");
    return ret;
  }
  public void setDefaultVM(int vm,int env,int factory)
  {
    dvm=this;
    SetDefaultVM(vm,env,factory);
  }
  public int loadBridge(String lib_file,String param)
  {
    return VMLoadBridge(lib_file,param);
  }
  public String createObject(String cls_name,String param)
  {
    LBridge.SetNotJavaClass(1);
    String ret=NewDefaultObject(cls_name,param);
    LBridge.SetNotJavaClass(0);
    return ret;
  }
  public String invoke(Object sender,String obj,String method_name,String param)
  {
    return Invoke(sender,obj,method_name,param);
  }
  public void delegateMethod(String delegated_obj,String method_name,Object receiver,Method m)
  {
    int obj_index=LBridge.Bridge.setObject(receiver);
    DelegateMethod(delegated_obj,method_name,obj_index,m.getName(),m.toString(),m.getReturnType().toString());
  }
  public Method getMethodByName(Class cls,String method_name)
  {
    Method[] methods = cls.getDeclaredMethods();
    for (int i=0; i<methods.length; i++) {
        if(methods[i].getName().equals(method_name)){
        	return methods[i];
        }
    }
    return null;    
  }
  
  public String shareExists(Object obj,String share_name)
  {
    int obj_index=LBridge.Bridge.setObject(obj);
    return ShareExists(obj_index,obj.getClass().getName(),share_name);
  }

  //test code
  public static void main(String args[]){
    JFrame mainform=new JFrame();
    mainform.setVisible(true);

    dVM dvm=new dVM();
    dvm.createVM();
    dvm.loadBridge("VCL_Bridge.dll","");
    String sobj=dvm.createObject("TForm","0");
    dvm.invoke(dvm,sobj,"Show","");
  }
}
