class TImageList
{
public:
Controls::TCursor DragCursor;
bool Dragging;
int AllocBy;
Graphics::TColor BlendColor;
int Count;
TDrawingStyle DrawingStyle;
int Height;
Imglist::TImageType ImageType;
bool Masked;
bool ShareImages;
int Width;

public:
__fastcall TImageList(TComponent* AOwner);
bool __fastcall BeginDrag(HWND Window, int X, int Y);
bool __fastcall DragLock(HWND Window, int XPos, int YPos);
bool __fastcall DragMove(int X, int Y);
void __fastcall DragUnlock(void);
bool __fastcall EndDrag(void);
TPoint __fastcall GetHotSpot();
void __fastcall HideDragImage(void);
bool __fastcall SetDragImage(int Index, int HotSpotX, int HotSpotY);
void __fastcall ShowDragImage(void);
int __fastcall Add(Graphics::TBitmap* Image, Graphics::TBitmap* Mask);
int __fastcall AddIcon(Graphics::TIcon* Image);
void __fastcall AddImages(Imglist::TCustomImageList* Value);
void __fastcall Assign(Classes::TPersistent* Source);
void __fastcall Clear(void);
void __fastcall Delete(int Index);
void __fastcall Draw(Graphics::TCanvas* Canvas, int X, int Y, int Index, bool Enabled);
void __fastcall DrawOverlay(Graphics::TCanvas* Canvas, int X, int Y, int ImageIndex, TOverlay Overlay, bool Enabled);
bool __fastcall FileLoad(TResType ResType, AnsiString Name, Graphics::TColor MaskColor);
void __fastcall GetBitmap(int Index, Graphics::TBitmap* Image);
void __fastcall GetIcon(int Index, Graphics::TIcon* Image);
HBITMAP __fastcall GetImageBitmap(void);
HBITMAP __fastcall GetMaskBitmap(void);
void __fastcall Insert(int Index, Graphics::TBitmap* Image, Graphics::TBitmap* Mask);
void __fastcall InsertIcon(int Index, Graphics::TIcon* Image);
void __fastcall InsertMasked(int Index, Graphics::TBitmap* Image, Graphics::TColor MaskColor);
void __fastcall Move(int CurIndex, int NewIndex);
bool __fastcall Overlay(int ImageIndex, TOverlay Overlay);
void __fastcall Replace(int Index, Graphics::TBitmap* Image, Graphics::TBitmap* Mask);
void __fastcall ReplaceIcon(int Index, Graphics::TIcon* Image);
void __fastcall ReplaceMasked(int Index, Graphics::TBitmap* NewImage, Graphics::TColor MaskColor);

public:
TNotifyEvent OnChange;
};

