class TMenuItem
{
public:
bool AutoCheck;
TMenuItemAutoFlag AutoHotkeys;
Graphics::TBitmap* Bitmap;
TMenuBreak Break;
AnsiString Caption;
bool Checked;
int Count;
bool Enabled;
Byte GroupIndex;
HMENU Handle;
AnsiString Hint;
int ImageIndex;
int MenuIndex;
TMenuItem* Parent;
TShortCut ShortCut;
bool Visible;

public:
__fastcall TMenuItem(TComponent* AOwner);

TMenuItem* Get__Items(int Index);

void __fastcall Add(TMenuItem* Item);
void __fastcall Clear(void);
void __fastcall Click(void);
void __fastcall Delete(int Index);
TMenuItem* __fastcall Find(AnsiString ACaption);
TCustomImageList* __fastcall GetImageList(void);
TComponent* __fastcall GetParentComponent(void);
TMenu* __fastcall GetParentMenu(void);
bool __fastcall HasParent();
int __fastcall IndexOf(TMenuItem* Item);
void __fastcall InitiateAction(void);
void __fastcall Insert(int Index, TMenuItem* Item);
int __fastcall InsertNewLineAfter(TMenuItem* AItem);
int __fastcall InsertNewLineBefore(TMenuItem* AItem);
bool __fastcall IsLine(void);
int __fastcall NewBottomLine(void);
void __fastcall Remove(TMenuItem* Item);
bool __fastcall RethinkHotkeys(void);
bool __fastcall RethinkLines(void);

public:
TAdvancedMenuDrawItemEvent OnAdvancedDrawItem;
TNotifyEvent OnClick;
TMenuDrawItemEvent OnDrawItem;
TMenuMeasureItemEvent OnMeasureItem;
};

