class TRichEdit
{
public:
TTextAttributes* DefAttributes;
bool HideScrollBars;
bool HideSelection;
TStrings* Lines;
TRect PageRect;
TParaAttributes* Paragraph;
bool PlainText;
TTextAttributes* SelAttributes;
int SelLength;
int SelStart;
AnsiString SelText;
TAlignment Alignment;
TPoint CaretPos;
TScrollStyle ScrollBars;
bool WantReturns;
bool WantTabs;
bool WordWrap;
TBorderStyle BorderStyle;
bool CanUndo;
int MaxLength;
bool Modified;
bool ReadOnly;

public:
__fastcall TRichEdit(TComponent* AOwner);
void __fastcall Clear(void);
int __fastcall FindText(const AnsiString SearchStr, int StartPos, int Length, TSearchTypes Options);
int __fastcall GetSelTextBuf(char * Buffer, int BufSize);
void __fastcall Print(const AnsiString Caption);
void __fastcall ClearSelection(void);
void __fastcall ClearUndo(void);
void __fastcall CopyToClipboard(void);
void __fastcall CutToClipboard(void);
void __fastcall PasteFromClipboard(void);
void __fastcall SelectAll(void);
void __fastcall SetSelTextBuf(char * Buffer);
void __fastcall Undo(void);

public:
TNotifyEvent OnChange;
TRichEditProtectChange OnProtectChange;
TRichEditResizeEvent OnResizeRequest;
TRichEditSaveClipboard OnSaveClipboard;
TNotifyEvent OnSelectionChange;

TNotifyEvent OnEnter;
TNotifyEvent OnExit;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;

TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TEndDragEvent OnEndDrag;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TMouseWheelEvent OnMouseWheel;
TMouseWheelUpDownEvent OnMouseWheelDown;
TMouseWheelUpDownEvent OnMouseWheelUp;
TStartDockEvent OnStartDock;
TStartDragEvent OnStartDrag;
};

