class TTreeView
{
public:
bool AutoExpand;
Forms::TBorderStyle BorderStyle;
Graphics::TCanvas* Canvas;
int ChangeDelay;
Comctrls::TTreeNode* DropTarget;
bool HideSelection;
bool HotTrack;
Imglist::TCustomImageList* Images;
int Indent;
Comctrls::TTreeNodes* Items;
bool MultiSelect;
Comctrls::TMultiSelectStyle MultiSelectStyle;
bool ReadOnly;
bool RightClickSelect;
bool RowSelect;
Comctrls::TTreeNode* Selected;
unsigned int SelectionCount;
bool ShowButtons;
bool ShowLines;
bool ShowRoot;
Comctrls::TSortType SortType;
Imglist::TCustomImageList* StateImages;
bool ToolTips;
Comctrls::TTreeNode* TopItem;

public:
__fastcall TTreeView(TComponent* AOwner);

Comctrls::TTreeNode* Get__Selections(int Index);

bool __fastcall AlphaSort(bool ARecurse);
void __fastcall ClearSelection(bool KeepPrimary);
void __fastcall Deselect(Comctrls::TTreeNode* Node);
Comctrls::TTreeNode* __fastcall FindNextToSelect(void);
void __fastcall FullCollapse(void);
void __fastcall FullExpand(void);
Comctrls::TTreeNode* __fastcall GetNodeAt(int X, int Y);
bool __fastcall IsEditing(void);
void __fastcall LoadFromFile(const AnsiString FileName);
void __fastcall LoadFromStream(TStream* Stream);
void __fastcall SaveToFile(AnsiString FileName);
void __fastcall SaveToStream(TStream* Stream);
void __fastcall Select(TList* Nodes);
void __fastcall Subselect(Comctrls::TTreeNode* Node, bool Validate);

public:
TTVExpandedEvent OnAddition;
TTVAdvancedCustomDrawEvent OnAdvancedCustomDraw;
TTVCustomDrawItemEvent OnCustomDrawItem;
TTVChangedEvent OnChange;
TTVChangingEvent OnChanging;
TTVExpandedEvent OnCollapsed;
TTVCollapsingEvent OnCollapsing;
TTVCompareEvent OnCompare;
TTVCustomDrawEvent OnCustomDraw;
TTVExpandedEvent OnDeletion;
TTVEditedEvent OnEdited;
TTVEditingEvent OnEditing;
TTVExpandedEvent OnExpanded;
TTVExpandingEvent OnExpanding;
TTVExpandedEvent OnGetImageIndex;
TTVExpandedEvent OnGetSelectedIndex;

TNotifyEvent OnEnter;
TNotifyEvent OnExit;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;

TNotifyEvent OnClick;
TNotifyEvent OnDblClick;
TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TEndDragEvent OnEndDrag;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TStartDockEvent OnStartDock;
TStartDragEvent OnStartDrag;
};

