// DangerousBrowserView.h : interface of the CDangerousBrowserView class
//


#pragma once


class CDangerousBrowserView : public CHtmlView
{
protected: // create from serialization only
	CDangerousBrowserView();
	DECLARE_DYNCREATE(CDangerousBrowserView)

// Attributes
public:
	CDangerousBrowserDoc* GetDocument() const;

	CComPtr<IDispatch> m_pDisp;
	CComPtr<IHTMLDocument2> m_spDoc;
	dobject php_object;
	dobject JavaScriptHelper;

// Operations
public:
	void LoadHtmlData(LPDISPATCH pDisp,char *html_text);

// Overrides
	public:
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct

// Implementation
public:
	virtual ~CDangerousBrowserView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	void OnNavigateComplete2(LPCTSTR lpszURL);

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnInvokePHP();
	afx_msg void OnExecuteJavaScript();
	afx_msg void OnExecuteJava();
};

#ifndef _DEBUG  // debug version in DangerousBrowserView.cpp
inline CDangerousBrowserDoc* CDangerousBrowserView::GetDocument() const
   { return reinterpret_cast<CDangerousBrowserDoc*>(m_pDocument); }
#endif

