unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  dVM, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;
var
  Form1: TForm1;

type
  JavaUIDelphiBL = class
  public
    function OnButton1Click(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
    function OnEdit1Change(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
  public
  Button1,Edit1,Memo1 :WideString;
  dVM :TdVM;
end;

var
  ui :JavaUIDelphiBL;

implementation

{$R *.dfm}

procedure CreateJavaUI();
var j:WideString;
begin
  ui := JavaUIDelphiBL.Create;
  ui.dVM :=TdVM.Create();
  ui.dVM.Build();
  ui.dVM.LoadBridge('Java_Bridge.dll','');

  j := ui.dVM.DefaultNewObject('SwingApplication','');
  ui.dVM.Invoke('obj_0',PWideChar(j),'StartupMe','');

  ui.Button1 := ui.dVM.GetSharedObject('Button1');
  ui.dVM.DelegatedStdcall(PWideChar(ui.Button1),'actionPerformed','',0,ui,ui.OnButton1Click);

  ui.Edit1 := ui.dVM.GetSharedObject('Edit1');
  ui.dVM.DelegatedStdcall(PWideChar(ui.Edit1),'keyPressed','',0,ui,ui.OnEdit1Change);

  ui.Memo1 := ui.dVM.GetSharedObject('Memo1');
end;

function JavaUIDelphiBL.OnButton1Click(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
var
  v,ret:WideString;
begin
  v := '"'#$D#$A'Button1 clicked."';
  ret := dVM.Invoke('obj_0',PWideChar(Memo1),'append',PWideChar(v));
end;
function JavaUIDelphiBL.OnEdit1Change(sender: PWideChar; func_name: PWideChar; param: PWideChar):PWideChar;stdcall;
var
  v,ret:WideString;
begin
  v := '"'#$D#$A'Edit1 changed."';
  ret := dVM.Invoke('obj_0',PWideChar(Memo1),'append',PWideChar(v));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ui.dVM.Destroy;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  CreateJavaUI();
end;

end.
