using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace CSharpUI
{
	public class CSharpForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.ComponentModel.Container components = null;

		public CSharpForm()
		{
			//fix Font finalyze bug
			try{Font=null;}catch(Exception){}

			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		private dVM dvm;
		public void StartupMe()
		{
			dvm=new dVM();

			dvm.ShareExistsObject("System.Windows.Forms.Button",button1,"Button1");
			dvm.ShareExistsObject("System.Windows.Forms.TextBox",textBox1,"Edit1");
			dvm.ShareExistsObject("System.Windows.Forms.TextBox",textBox2,"Memo1");
			Show();
		}

		#region Windows Form designer code
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(16, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(104, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "button1";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 40);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(104, 21);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(128, 8);
			this.textBox2.Multiline = true;
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(192, 56);
			this.textBox2.TabIndex = 2;
			this.textBox2.Text = "";
			// 
			// CSharpForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(328, 77);
			this.Controls.Add(this.textBox2);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.button1);
			this.Name = "CSharpForm";
			this.Text = "C# Form";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
