import java.io.*;
import java.util.*;
import javax.mail.util.*;
import javax.activation.*;
import java.net.InetAddress;
import java.util.Properties;
import java.util.Date;
import javax.swing.*;

import javax.mail.*;
import javax.mail.internet.*;

import com.sun.mail.smtp.*;

public class smtpsend {
private void showMsg(String msg) {
	/*JDialog dl;
	dl=new JDialog();
	dl.setTitle(msg);
	dl.show();*/
}
public boolean sendMail(String mailhost, String sender, String to, String acc_user, String acc_pwd, String subject, String body, String html_body) {
	try {
		showMsg(mailhost);
		showMsg(sender);
		showMsg(to);
		showMsg(acc_user);
		showMsg(acc_pwd);
		showMsg(subject);
		showMsg(body);
		showMsg(html_body);

		// construct the message
		Properties props = System.getProperties();
		Session session = Session.getDefaultInstance(props, null);
		Message msg = new MimeMessage(session);
		msg.setFrom(new InternetAddress(acc_user,sender));
		msg.setRecipients(Message.RecipientType.TO,InternetAddress.parse(to, false));
		msg.setSubject(subject);
	
		// attachments
		MimeMultipart mp = new MimeMultipart();
		//  text body
		MimeBodyPart text_attachment = new MimeBodyPart();
		text_attachment.setText(body);
		mp.addBodyPart(text_attachment);

		//  ***** HTML attachment
		MimeBodyPart html_attachment = new MimeBodyPart();
	    	html_attachment.setHeader("Content-Type" , "html" );
		html_attachment.setDataHandler(new DataHandler(new ByteArrayDataSource(html_body, "text/html")));
		mp.addBodyPart(html_attachment);

		msg.setContent(mp);

		//connect to send
		String prot = "smtp";
		SMTPTransport t=(SMTPTransport)session.getTransport(prot);
		t.connect(mailhost, acc_user, acc_pwd);
		t.sendMessage(msg, msg.getAllRecipients());
		t.close();
	} catch(javax.mail.internet.AddressException e) {
		showMsg(e.toString());

		return false;
	}
	catch(javax.mail.MessagingException e) {
		showMsg(e.toString());

		return false;
	}
	catch(java.io.UnsupportedEncodingException e) {
		showMsg(e.toString());

		return false;
	}
	catch(java.io.IOException e) {
		showMsg(e.toString());

		return false;
	}
	showMsg("finish");
	return true;
}
public boolean sendSample() {
	return sendMail(
		"smtp.163.com", //mailhost
		"your name", //sender;
		"yesry@sina.com", //to
		"luodiping@163.com", //account user
		"yourgod", //account password
		"the subject of test", //subject
		"text body", //body
		"<html><body>html body</body></html>" //html_body
	);
}
public static void main(String[] argv) {
	new smtpsend().sendSample();
	System.out.println("\nMail was sent successfully.");
    }
}
