class TBitmap
{
public:
Graphics::TCanvas* Canvas;
bool Empty;
HBITMAP Handle;
int Height;
bool IgnorePalette;
HBITMAP MaskHandle;
bool Monochrome;
HPALETTE Palette;
Graphics::TPixelFormat PixelFormat;
Graphics::TColor TransparentColor;
Graphics::TTransparentMode TransparentMode;
int Width;

public:
__fastcall TBitmap(void);
void __fastcall Assign(TPersistent* Source);
void __fastcall Dormant(void);
void __fastcall FreeImage(void);
bool __fastcall HandleAllocated(void);
void __fastcall LoadFromClipboardFormat(Word AFormat, int AData, HPALETTE APalette);
void __fastcall LoadFromResourceID(unsigned Instance, int ResID);
void __fastcall LoadFromResourceName(unsigned Instance, const AnsiString ResName);
void __fastcall LoadFromStream(Classes::TStream* Stream);
void __fastcall Mask(Graphics::TColor TransparentColor);
HBITMAP __fastcall ReleaseHandle(void);
HBITMAP __fastcall ReleaseMaskHandle(void);
HPALETTE __fastcall ReleasePalette(void);
void __fastcall SaveToClipboardFormat(Word AFormat, int AData, HPALETTE APalette);
void __fastcall SaveToStream(Classes::TStream* Stream);

public:
TNotifyEvent OnChange;
TProgressEvent OnProgress;
};

