class TCheckListBox
{
public:
bool AllowGrayed;
bool Flat;
Graphics::TColor HeaderBackgroundColor;
Graphics::TColor HeaderColor;
bool AutoComplete;
Forms::TBorderStyle BorderStyle;
Graphics::TCanvas* Canvas;
int Columns;
int Count;
bool IntegralHeight;
int ItemHeight;
int ItemIndex;
TStrings* Items;
bool MultiSelect;
int ScrollWidth;
int SelCount;
bool Sorted;
Stdctrls::TListBoxStyle Style;
int TabWidth;
int TopIndex;

public:
__fastcall TCheckListBox(TComponent* AOwner);

bool Get__Checked(int Index);
bool Get__ItemEnabled(int Index);
bool Get__Header(int Index);
Stdctrls::TCheckBoxState Get__State(int Index);
bool Get__Selected(int Index);

void __fastcall AddItem(AnsiString Item, TObject* AObject);
void __fastcall Clear(void);
void __fastcall ClearSelection(void);
void _fastcall DeleteSelected(void);
int __fastcall ItemAtPos(TPoint &Pos, bool Existing);
TRect __fastcall ItemRect(int Index);
void __fastcall SelectAll(void);

public:
TNotifyEvent OnClickCheck;
TLBGetDataEvent OnData;
TLBFindDataEvent OnDataFind;
TDrawItemEvent OnDrawItem;
TMeasureItemEvent OnMeasureItem;

TNotifyEvent OnEnter;
TNotifyEvent OnExit;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;

TNotifyEvent OnClick;
TNotifyEvent OnDblClick;
TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TEndDragEvent OnEndDrag;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TStartDockEvent OnStartDock;
TStartDragEvent OnStartDrag;
};

