class TCustomImageList
{
public:
int AllocBy;
Graphics::TColor BkColor;
Graphics::TColor BlendColor;
int Count;
TDrawingStyle DrawingStyle;
int Handle;
int Height;
TImageType ImageType;
bool Masked;
bool ShareImages;
int Width;

public:
__fastcall virtual TCustomImageList(Classes::TComponent* AOwner);
int __fastcall Add(Graphics::TBitmap* Image, Graphics::TBitmap* Mask);
int __fastcall AddIcon(Graphics::TIcon* Image);
void __fastcall AddImages(TCustomImageList* Value);
int __fastcall AddMasked(Graphics::TBitmap* Image, Graphics::TColor MaskColor);
void __fastcall Assign(Classes::TPersistent* Source);
void __fastcall Clear(void);
void __fastcall Delete(int Index);
void __fastcall Draw(Graphics::TCanvas* Canvas, int X, int Y, int Index, TDrawingStyle ADrawingStyle, TImageType AImageType, bool Enabled);
void __fastcall DrawOverlay(Graphics::TCanvas* Canvas, int X, int Y, int ImageIndex, TOverlay Overlay, bool Enabled);
bool __fastcall FileLoad(TResType ResType, const AnsiString Name, Graphics::TColor MaskColor);
void __fastcall GetBitmap(int Index, Graphics::TBitmap* Image);
TPoint __fastcall GetHotSpot();
void __fastcall GetIcon(int Index, Graphics::TIcon* Image, TDrawingStyle ADrawingStyle, TImageType AImageType);
HBITMAP __fastcall GetImageBitmap(void);
bool __fastcall GetInstRes(int Instance, TResType ResType, DWORD ResID, int Width, TLoadResources LoadFlags, Graphics::TColor MaskColor);
HBITMAP __fastcall GetMaskBitmap(void);
bool __fastcall GetResource(TResType ResType, const AnsiString Name, int Width, TLoadResources LoadFlags, Graphics::TColor MaskColor);
bool __fastcall HandleAllocated(void);
void __fastcall Insert(int Index, Graphics::TBitmap* Image, Graphics::TBitmap* Mask);
void __fastcall InsertIcon(int Index, Graphics::TIcon* Image)
void __fastcall InsertMasked(int Index, Graphics::TBitmap* Image, Graphics::TColor MaskColor);
void __fastcall Move(int CurIndex, int NewIndex);
bool __fastcall Overlay(int ImageIndex, TOverlay Overlay);
void __fastcall Replace(int Index, Graphics::TBitmap* Image, Graphics::TBitmap* Mask);
void __fastcall ReplaceIcon(int Index, Graphics::TIcon* Image);
void __fastcall ReplaceMasked(int Index, Graphics::TBitmap* NewImage, Graphics::TColor MaskColor);
bool __fastcall ResourceLoad(TResType ResType, const AnsiString Name, Graphics::TColor MaskColor);
};

