class TForm
{
public:
bool Active;
Controls::TWinControl* ActiveControl = {read=FActiveControl, write=SetActiveControl, stored=IsForm};
TForm* ActiveMDIChild = {read=GetActiveMDIChild};
bool AlphaBlend = {read=FAlphaBlend, write=SetAlphaBlend};
Byte AlphaBlendValue;
TFormBorderStyle BorderStyle;
Graphics::TCanvas* Canvas = {read=GeGraphics::TCanvas};
HWND ClientHandle = {read=FClientHandle, nodefault};
Types::TRect ClientRect = {read=GetClientRect};
int ClientWidth = {write=SetClientWidth, stored=IsClientSizeStored};
bool DropTarget = {read=FDropTarget, write=FDropTarget, nodefault};
TFormState FormState = {read=FFormState, nodefault};
TFormStyle FormStyle;
AnsiString HelpFile = {read=FHelpFile, write=FHelpFile};
bool KeyPreview;
int MDIChildCount;
Menus::TMainMenu* Menu;
Controls::TModalResult ModalResult;
TMonitor* Monitor;
TWinControl* Parent;
bool ParentBiDiMode;
int PixelsPerInch;
TPosition Position;
TPrintScale PrintScale;
bool Scaled;
TTileMode TileMode;
bool TransparentColor;
Graphics::TColor TransparentColorValue;
bool Visible;
Menus::TMenuItem* WindowMenu;
TWindowState WindowState;
AnsiString Caption; 
TColor Color;
TDragMode DragMode;

public:
__fastcall TForm(TComponent* AOwner);

TForm* Get__MDIChildren(int Index);

void __fastcall ArrangeIcons(void);
void __fastcall Cascade(void);
void __fastcall Next(void);
void __fastcall Previous(void);
void __fastcall Tile(void);
virtual void __fastcall AfterConstruction(void);
virtual void __fastcall BeforeDestruction(void);
void __fastcall Close(void);
virtual bool __fastcall CloseQuery(void);
void __fastcall DefocusControl(Controls::TWinControl* Control, bool Removing);
void __fastcall FocusControl(Controls::TWinControl* Control);
Graphics::TBitmap* __fastcall GetFormImage(void);
void __fastcall Hide(void);
void __fastcall MakeFullyVisible(TMonitor* AMonitor);
void __fastcall Print(void);
void __fastcall Release(void);
void __fastcall SendCancelMode(Controls::TControl* Sender);
virtual void __fastcall SetFocus(void);
virtual bool __fastcall SetFocusedControl(Controls::TWinControl* Control);
void __fastcall Show(void);
virtual int __fastcall ShowModal(void);
virtual bool __fastcall WantChildKey(Controls::TControl* Child, Messages::TMessage &Message);

public:
TNotifyEvent OnActivate = {read=FOnActivate, write=FOnActivate, stored=IsForm};
TCloseEvent OnClose = {read=FOnClose, write=FOnClose, stored=IsForm};
TCloseQueryEvent OnCloseQuery = {read=FOnCloseQuery, write=FOnCloseQuery, stored=IsForm};
TContextPopupEvent OnContextPopup = {read=FOnContextPopup, write=FOnContextPopup};
TNotifyEvent OnCreate = {read=FOnCreate, write=FOnCreate, stored=IsForm};
TNotifyEvent OnDeactivate = {read=FOnDeactivate, write=FOnDeactivate, stored=IsForm};
TNotifyEvent OnDestroy = {read=FOnDestroy, write=FOnDestroy, stored=IsForm};
TGetSiteInfoEvent OnGetSiteInfo = {read=FOnGetSiteInfo, write=FOnGetSiteInfo};
THelpEvent OnHelp = {read=FOnHelp, write=FOnHelp};
TNotifyEvent OnHide = {read=FOnHide, write=FOnHide, stored=IsForm};
TNotifyEvent OnPaint = {read=FOnPaint, write=FOnPaint, stored=IsForm};
TShortCutEvent OnShortCut = {read=FOnShortCut, write=FOnShortCut};
TNotifyEvent OnShow = {read=FOnShow, write=FOnShow, stored=IsForm};

TDockDropEvent OnDockDrop;
TDockOverEvent OnDockOver;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;
TUnDockEvent OnUnDock;

TNotifyEvent OnClick;
TConstrainedResizeEvent OnConstrainedResize;
TNotifyEvent OnDblClick;
TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TMouseWheelEvent OnMouseWheel;
TMouseWheelUpDownEvent OnMouseWheelDown;
TMouseWheelUpDownEvent OnMouseWheelUp;
TNotifyEvent OnResize;
TStartDockEvent OnStartDock;
};
