class TListView
{
public:
int AllocBy;
Forms::TBorderStyle BorderStyle;
TRect BoundingRect;
Graphics::TCanvas* Canvas;
bool Checkboxes;
bool ColumnClick;
Comctrls::TListItem* DropTarget;
bool FlatScrollBars;
bool FullDrag;
bool GridLines;
bool HideSelection;
bool HotTrack;
TListHotTrackStyles HotTrackStyles;
int HoverTime;
Comctrls::TListItem* ItemFocused;
int ItemIndex;
Comctrls::TListItems* Items;
Imglist::TCustomImageList* LargeImages;
bool MultiSelect;
bool OwnerData;
bool OwnerDraw;
bool ReadOnly;
bool RowSelect;
int SelCount;
Comctrls::TListItem* Selected;
bool ShowColumnHeaders;
Comctrls::TSortType SortType;
Imglist::TCustomImageList* StateImages;
Comctrls::TListItem* TopItem;
TPoint ViewOrigin;
Comctrls::TViewStyle ViewStyle;
int VisibleRowCount;

public:
__fastcall TListView(TComponent* AOwner);

Comctrls::TListColumn* Get__Column(int Index);

bool __fastcall AlphaSort(void);
void __fastcall Arrange(TListArrangement Code);
void __fastcall Clear(void);
void __fastcall ClearSelection(void);
void __fastcall DeleteSelected(void);
Comctrls::TListItem* __fastcall FindCaption(int StartIndex, AnsiString Value, bool Partial, bool Inclusive, bool Wrap);
Comctrls::TListItem* __fastcall FindData(int StartIndex, void * Value, bool Inclusive, bool Wrap);
Comctrls::TListItem* __fastcall GetItemAt(int X, int Y);
Comctrls::TListItem* __fastcall GetNextItem(Comctrls::TListItem* StartItem, Comctrls::TSearchDirection Direction, Comctrls::TItemStates States);
AnsiString __fastcall GetSearchString();
bool __fastcall IsEditing(void);
void __fastcall Scroll(int DX, int DY);
void __fastcall SelectAll(void);
int __fastcall StringWidth(AnsiString S);
void __fastcall UpdateItems(int FirstIndex, int LastIndex);
void __fastcall AddItem(AnsiString Item, System::TObject* AObject);

public:
TLVAdvancedCustomDrawEvent OnAdvancedCustomDraw;
TLVAdvancedCustomDrawItemEvent OnAdvancedCustomDrawItem;
TLVAdvancedCustomDrawSubItemEvent OnAdvancedCustomDrawSubItem;
TLVChangeEvent OnChange;
TLVChangingEvent OnChanging;
TLVColumnClickEvent OnColumnClick;
TNotifyEvent OnColumnDragged;
TLVColumnRClickEvent OnColumnRightClick;
TLVCompareEvent OnCompare;
TLVCustomDrawEvent OnCustomDraw;
TLVCustomDrawItemEvent OnCustomDrawItem;
TLVCustomDrawSubItemEvent OnCustomDrawSubItem;
TLVOwnerDataEvent OnData;
TLVOwnerDataFindEvent OnDataFind;
TLVOwnerDataHintEvent OnDataHint;
TLVOwnerDataStateChangeEvent OnDataStateChange;
TLVDeletedEvent OnDeletion;
TLVDrawItemEvent OnDrawItem;
TLVEditedEvent OnEdited;
TLVEditingEvent OnEditing;
TLVNotifyEvent OnGetImageIndex;
TLVSubItemImageEvent OnGetSubItemImage;
TLVInfoTipEvent OnInfoTip;
TLVDeletedEvent OnInsert;
TLVSelectItemEvent OnSelectItem;

TNotifyEvent OnEnter;
TNotifyEvent OnExit;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;

TNotifyEvent OnClick;
TNotifyEvent OnDblClick;
TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TEndDragEvent OnEndDrag;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TNotifyEvent OnResize;
TStartDockEvent OnStartDock;
TStartDragEvent OnStartDrag;
};

