class TMemo
{
public:
TAlignment Alignment;
TPoint CaretPos;
TStrings* Lines;
TScrollStyle ScrollBars;
bool WantReturns;
bool WantTabs;
bool WordWrap;
TBorderStyle BorderStyle;
bool CanUndo;
bool HideSelection;
int MaxLength;
bool Modified;
bool OEMConvert;
bool ReadOnly;
int SelLength;
int SelStart;
AnsiString SelText;

public:
__fastcall TMemo(TComponent* AOwner);
void __fastcall Clear(void);
void __fastcall ClearSelection(void);
void __fastcall ClearUndo(void);
void __fastcall CopyToClipboard(void);
void __fastcall CutToClipboard(void);
void __fastcall DefaultHandler(void *Message);
int __fastcall GetSelTextBuf(char * Buffer, int BufSize);
void __fastcall PasteFromClipboard(void);
void __fastcall SelectAll(void);
void __fastcall SetSelTextBuf(char * Buffer);
void __fastcall Undo(void);

public:
TNotifyEvent OnChange;

TNotifyEvent OnEnter;
TNotifyEvent OnExit;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;

TNotifyEvent OnClick;
TNotifyEvent OnDblClick;
TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TEndDragEvent OnEndDrag;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TStartDockEvent OnStartDock;
TStartDragEvent OnStartDrag;
};

