class TMemoryStream
{
public:
__int64 Position;
__int64 Size;
void * Memory;

public:
__fastcall TMemoryStream(void);

void __fastcall Clear(void);
void __fastcall LoadFromFile(const AnsiString FileName);
void __fastcall LoadFromStream(TStream* Stream);
__int64 __fastcall CopyFrom(TStream* Source, __int64 Count);
void __fastcall FixupResourceHeader(int FixupInfo);
int __fastcall Read(void *Buffer, int Count);
void __fastcall ReadBuffer(void *Buffer, int Count);
TComponent* __fastcall ReadComponent(TComponent* Instance);
TComponent* __fastcall ReadComponentRes(TComponent* Instance);
void __fastcall ReadResHeader(void);
int __fastcall Seek(int Offset, Word Origin);
int __fastcall Write(const void *Buffer, int Count);
void __fastcall WriteBuffer(const void *Buffer, int Count);
void __fastcall WriteComponent(TComponent* Instance);
void __fastcall WriteComponentRes(const AnsiString ResName, TComponent* Instance);
void __fastcall WriteDescendent(TComponent* Instance, TComponent* Ancestor);
void __fastcall WriteDescendentRes(const AnsiString ResName, TComponent* Instance, TComponent* Ancestor);
void __fastcall WriteResourceHeader(const AnsiString ResName, int FixupInfo);
};

