class TStringGrid
{
public:
TBorderStyle BorderStyle;
int Col;
int ColCount;
int DefaultColWidth;
int DefaultRowHeight;
bool EditorMode;
TColor FixedColor;
int FixedCols;
int FixedRows;
int GridHeight;
int GridLineWidth;
int GridWidth;
int LeftCol;
TGridOptions Options;
int Row;
int RowCount;
TScrollStyle ScrollBars;
TGridRect Selection;
int TopRow;
int VisibleColCount;
int VisibleRowCount;
Graphics::TCanvas* Canvas;

public:
__fastcall TStringGrid(TComponent* AOwner);

AnsiString Get__Cells(int col,int row);
TObject* Get__Objects(int col,int row);
TStrings* Get__Cols(int Index);
TStrings* Get__Rows(int Index);
int Get__ColWidths(int Index);
bool Get__TabStops(int Index);

TRect __fastcall CellRect(int ACol, int ARow);
TPoint __fastcall MouseToCell(int X, int Y);
TGridCoord __fastcall MouseCoord(int X, int Y);

public:
TMovedEvent OnColumnMoved;
TDrawCellEvent OnDrawCell;
TGetEditEvent OnGetEditMask;
TGetEditEvent OnGetEditText;
TMovedEvent OnRowMoved;
TSelectCellEvent OnSelectCell;
TSetEditEvent OnSetEditText;
TNotifyEvent OnTopLeftChanged;

TNotifyEvent OnEnter;
TNotifyEvent OnExit;
TKeyEvent OnKeyDown;
TKeyPressEvent OnKeyPress;
TKeyEvent OnKeyUp;

TNotifyEvent OnClick;
TNotifyEvent OnDblClick;
TDragDropEvent OnDragDrop;
TDragOverEvent OnDragOver;
TEndDragEvent OnEndDock;
TEndDragEvent OnEndDrag;
TMouseEvent OnMouseDown;
TMouseMoveEvent OnMouseMove;
TMouseEvent OnMouseUp;
TStartDockEvent OnStartDock;
TStartDragEvent OnStartDrag;
};

