class TTreeNode
{
public:
int Count;
bool Cut;
void * Data;
bool Deleting;
bool DropTarget;
bool Expanded;
bool Focused;
HWND Handle;
bool HasChildren;
int ImageIndex;
int Index;
bool IsVisible;
int Level;
int OverlayIndex;
Comctrls::TTreeNodes* Owner;
Comctrls::TTreeNode* Parent;
bool Selected;
int SelectedIndex;
int StateIndex;
AnsiString Text;
Comctrls::TCustomTreeView* TreeView;

public:
__fastcall TTreeNode(Comctrls::TTreeNodes* AOwner);

Comctrls::TTreeNode* Get__Item(int Index);

bool __fastcall AlphaSort(bool ARecurse);
void __fastcall Assign(TPersistent* Source);
void __fastcall Collapse(bool Recurse);
void __fastcall Delete(void);
void __fastcall DeleteChildren(void);
TRect __fastcall DisplayRect(bool TextOnly);
void __fastcall EndEdit(bool Cancel);
void __fastcall Expand(bool Recurse);
Comctrls::TTreeNode* __fastcall getFirstChild(void);
HWND __fastcall GetHandle(void);
Comctrls::TTreeNode* __fastcall GetLastChild(void);
Comctrls::TTreeNode* __fastcall GetNext(void);
Comctrls::TTreeNode* __fastcall getNextSibling(void);
Comctrls::TTreeNode* __fastcall GetNextVisible(void);
Comctrls::TTreeNode* __fastcall GetPrev(void);
Comctrls::TTreeNode* __fastcall GetPrevChild(Comctrls::TTreeNode* Value);
Comctrls::TTreeNode* __fastcall getPrevSibling(void);
Comctrls::TTreeNode* __fastcall GetPrevVisible(void);
bool __fastcall HasAsParent(Comctrls::TTreeNode* Value);
int __fastcall IndexOf(Comctrls::TTreeNode* Value);
bool IsFirstNode();
void __fastcall MakeVisible(void);
void __fastcall MoveTo(Comctrls::TTreeNode* Destination, Comctrls::TNodeAttachMode Mode);
Comctrls::TTreeNode* do_operator(int Index);
};

