class TWinControl 
{
public:
bool AlignDisabled;
Graphics::TBrush* Brush;
TPoint ClientOrigin;
TRect ClientRect;
int ControlCount;
int DockClientCount;
HANDLE Handle;
HWND ParentWindow;
bool Showing;
short TabOrder;
bool TabStop;
int VisibleDockClientCount;

public:
__fastcall TWinControl(Classes::TComponent* AOwner);

Controls::TControl* Get__Controls(int Index);
Controls::TControl* Get__DockClients(int Index);

void __fastcall Broadcast(void *Message);
bool __fastcall CanFocus(void);
bool __fastcall ContainsControl(Controls::TControl* Control);
Controls::TControl* __fastcall ControlAtPos(const Types::TPoint Pos, bool AllowDisabled, bool AllowWinControls);
void __fastcall DisableAlign(void);
void __fastcall EnableAlign(void)
Controls::TControl* __fastcall FindChildControl(const AnsiString ControlName);
bool __fastcall HandleAllocated(void);
void __fastcall HandleNeeded(void);
void __fastcall InsertControl(Controls::TControl* AControl);
void __fastcall Invalidate(void);
void __fastcall PaintControls(HDC DC, Controls::TControl* First)
void __fastcall PaintTo(HDC DC, int X, int Y);
void __fastcall RemoveControl(Controls::TControl* AControl);
void __fastcall Repaint(void);
void __fastcall ScaleBy(int M, int D);
void __fastcall ScrollBy(int DeltaX, int DeltaY);
void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
void __fastcall SetFocus(void);
void __fastcall Update(void);
void __fastcall UpdateControlState(void);

public:
};

